/**************************************************************************
 * HeXHub C++ SDK 0.4 Files Copyright (C) 2007-2008 Mikhail Polenin       *
 * HeXHub is Copyright(C) Albu Cristian Laurentiu                         *
 * This SDK's Purpose is to wrap around the HeXHub API to help plugin     *
 * developers organize their function calls and have more ease in coding  *
 * HeXHub Plugins.                                                        *
 * Files that should be included in this distribution:                    *
 *    HeXHubSDK.h - Header                                                *
 *    HeXHubSDK.cpp - Source File                                         *
 *    SDKReadme.txt - Documentation                                       *
 *    license.txt - License Information                                   *
 **************************************************************************/

//EDIT THIS VALUE FOR THE HEXHUB VERSION YOU INTEND TO WRITE FOR!!!!
#define HEX_VERSION 307





#ifndef WINDOWS_H
#include "windows.h"
#define WINDOWS_H
#endif

#define NICKBUFF		41
#define IPBUFF			15

#define ID_SECURITY_BOT	0

	typedef long SDWORD;
	typedef short SWORD;
	typedef char SBYTE;
	typedef long long SQWORD;

	typedef struct _profileInfo {
		SBYTE	rights[8];	//rights
		SDWORD	minAccess;	//minimum access
		SDWORD	maxAccess;	//maximum access
		SDWORD	accessIncrease;	//increment
		SDWORD	availability;	//availability in hours (0 = permanent)
	} profileInfo;

	typedef struct _accountInfo {
		SDWORD	reserved1;	//reserved
		SBYTE	name[40];	//user name
		SWORD	profileId;	//profile identifier
		SWORD	profileReset;	//identifier of the profile it resets to
		SDWORD	userId;		//user identifier
		SBYTE	rights[8];	//rights
		SDWORD	access;		//access level
		SDWORD	maxAccess;	//maximum access for current profile
		SDWORD	accessTime;	//timer increment
		SDWORD	availability;	//account availability
		SDWORD	maxClones;	//maximum clones allowed (if the account is for an IP)
		SBYTE	language[2];	//language identifier
		SWORD	mode;		//last chat filter used
		SBYTE	password[40];	//password
		SBYTE	ipInformation;	//1 = IP/IP range, 2 = ISP, 3 = MAC
		SDWORD	IP1;		//first IP in range
		SDWORD	IP2;		//last IP in range
		SBYTE	ipstr[40];	//string containing IP, ISP or MAC (as ipInformation specifies)
		SDWORD	reserved2;	//reserved
		SBYTE	creator[40];	//nickname of the admin who created this account
		SBYTE	reserved3[8];	//reserved, date+time
		SBYTE	modifier[40];	//nickname of the last admin who modified this account
		SBYTE	reserved4[8];	//reserved, date+time
		SBYTE	reserved5[50];	//reserved
		SBYTE	reason[220];	//reason or comment
		SBYTE	reserved6[62];	//reserved
	} accountInfo;

	typedef struct _ipInfo {
		SDWORD	lastIp;		//IP number
		SWORD	timer1;
		SWORD	timer2;
		SWORD	timer3;
		SWORD	timer4;
		SWORD	timer5;		//timers used to check for reconnect flood
		SBYTE	fcount;		//number of reconnects
		SBYTE	flags1;		//flags
					//bit 0 => reserved
					//bit 1 => reserved
					//bit 2 => used by DDoS filter
					//bit 3 => IP was checked for public proxy
					//bit 4 => IP is a public proxy
					//bit 5 => from this IP a user was disconnected because of incorrect settings for active mode
					//bit 6 => this IP beSDWORDs to a faker and a notification message was sent
					//bit 7 => reserved
		SDWORD	lastconn;	//last connection time in seconds relative to hub startup
		SDWORD	tc_save;	//reserved
		SBYTE	langtmp;	//language index in language table
		SBYTE	invpasvd;	//number of invalid passwords sent
		SBYTE	timeskicked;	//number of kicks
		SBYTE	modetmp;	//last chat filter's index (used by older versions)
		SBYTE	country;	//country name index
		SBYTE	flagextra;	//flags
					//bit 0 => country ID was detected
					//bit 1 => user was banned for forbidden files in share, share size must change
		SBYTE	share_check;	//checksum for share size
		SBYTE	macaddr[6];	//MAC address
		SBYTE	reserved[3];	//reserved
	} ipInfo;

	typedef struct _syn_info {
		SDWORD	lastCount;	//number of seconds since firewall was started when packet was sent
		SDWORD	sourceIP;	//source IP
		SDWORD	destinationIP;	//destination IP
		SDWORD	lastPort;	//destination port
		SWORD	isflood;	//flood indicator, 1 = flood is detected
		SWORD	reserved;	//reserved
	} syn_info;

	typedef struct _syn_str {
		SBYTE	syn_idx;	//index of next syn_info structure that will be used
		SBYTE	isFlood;	//detected flood type, 2 = portscan, 3 = SYN flood, 4 = UDP flood, 5 = ICMP flood
		SDWORD	lastIP;		//last IP that was detected as flooding
		syn_info sInfo[20];	//information about last sent packets
	} syn_str;

	typedef struct _firewallSettingsInfo {
		SWORD	pcapFlags;	//flags used by WinPCap procedures, bit 0 = WinPCap enabled, bit 1 = adapters were detected
		SWORD	pcapAdapters;	//flags used by WinPCap procedures to enable / disable adapters (bit 0 = first adapter, bit 1 = second adapter, etc)
		SDWORD	pcapTimeout;	//timeout used by WinPCap procedures for capturing packets
		SBYTE	maxSyn;		//maximum number of TCP/SYN packets / second allowed from same IP
		SBYTE	maxUdp;		//maximum number of UDP packets / second allowed from same IP
		SBYTE	maxIcmp;	//maximum number of ICMP packets / second allowed from same IP
		SBYTE	firewallFlags;	//flags used by firewall
					//	bit 0 => firewall is registered
					//	bit 1 => firewall is loaded
					//	bit 2 => SYN flood check on hub's ports is enabled
					//	bit 3 => SYN flood check on ports not used by hub is enabled
					//	bit 4 => incoming ICMP traffic is blocked
					//	bit 5 => TCP/RST packets are not sent on connection resets
					//	bit 6 => if flood is detected, a _ban0_ is added for source IP
					//	bit 7 => if flood is detected, a notification message is sent in opchat
		int	hubPortSyn;	//maximum number of SYN packets allowed to be sent to a port opened by hub
		int	otherPortsSyn;	//maximum number of SYN packets allowed to be sent to all other ports that are not used by hub
	} firewallSettingsInfo;

	typedef struct _firewallStatisticsInfo {
		syn_str	synFlood;	//statistics for SYN packets
		syn_str	udpFlood;	//statistics for UDP packets
		syn_str	icmpFlood;	//statistics for ICMP packets
		SDWORD	ddosSyn;	//filtered SYN packets sent from IPs found in DDoS filter
		SDWORD	banSyn;		//filtered SYN packets sent from banned IPs
		SDWORD	fltPort;	//filtered SYN packets sent to all registered ports if flood was detected
		SDWORD	reserved;	//pointer to last syn_str structure that was written
	} firewallStatisticsInfo;


typedef struct _iprange {
	SDWORD startip;
	SDWORD endip;
} iprange;



	typedef struct _floodDefInfo {
		LPSTR	lpszCmdName;	//command name
		FARPROC	cmdproc;	//address of procedure that is called when specified command is received
		SDWORD	floodFlags;	//flags used by flood check procedures
					//bit  0
					//bit  1
					//bit  2 => bits 0,1,2 are used as follows:
						// 210
						// 000 = /session
						// 001 = /second
						// 010 = /minute
						// 011 = /hour
						// 100 = /day
					//bit  3
					//bit  4
					//bit  5 => bits 3,4,5 are used as follows:
						// 543
						// 000 = /session
						// 001 = /second
						// 010 = /minute
						// 011 = /hour
						// 100 = /day
					//bit  8 => keep only the last of a command chain
					//bit  9 => restriction enabled: "allow only ... from one"
					//bit 10 => restriction enabled: "allow only ... from all"
					//bit 11 => reserved
					//bit 12 => if flood is detected, user is delayed
					//bit 13 => if flood is detected, command is ignored
					//bit 14 => if flood is detected, a notification message will be sent
					//bit 15 => if flood is detected, user will be disconnected
					//bit 16 => do Not combine messages
		SWORD	flcnt1;		//maximum allowed from one user
		SWORD	flcnt2;		//maximum allowed from all users
		SDWORD	counter;	//total number of commands received from all users (for !stats command)
		SDWORD	cmdFlags;	//flags related to specified command
		SDWORD	cmdParam1;	//parameters specific to this command
		SDWORD	cmdParam2;	//parameters specific to this command
		SDWORD	lastTick;	//number of seconds since hub was started
		SWORD	_flcnt1;	//command counter, all users
		SWORD	_flcnt2;	//number of times when flood was detected from all users
	} floodDefInfo;


	typedef struct _userFloodInfo{
		SDWORD	lasttick;	//number of seconds since hub was started
		SWORD	flcnt1;		//command counter, current user
		SWORD	flcnt2;		//command counter, all users
		SBYTE	flag1;		//command flags
	} userFloodInfo;

#define CONNECT0		0x0000000000000001
#define CONNECT1		0x0000000000000002
#define CONNECT2		0x0000000000000004
#define CONNECT3		0x0000000000000008
#define CONNECT4		0x0000000000000010
#define CHAT0			0x0000000000000020
#define CHAT1			0x0000000000000040
#define CHAT2			0x0000000000000080
#define CHAT3			0x0000000000000100
#define CMD0			0x0000000000000200
#define SAY				0x0000000000000400
#define TOPIC			0x0000000000000800
#define MOTD			0x0000000000001000
#define MODE			0x0000000000002000
#define INFO0			0x0000000000004000
#define INFO1			0x0000000000008000
#define INFO2			0x0000000000010000
#define HUBLIST0		0x0000000000020000
#define HUBLIST1		0x0000000000040000
#define TAGS0			0x0000000000080000
#define KICK0			0x0000000000100000
#define KICK1			0x0000000000200000
#define KICK2			0x0000000000400000
#define KICK3			0x0000000000800000
#define KICK4			0x0000000001000000
#define OP				0x0000000002000000
#define OP0				0x0000000004000000
#define OP1				0x0000000008000000
#define ADM0			0x0000000010000000
#define ADM1			0x0000000020000000
#define ADM2			0x0000000040000000
#define ADM3			0x0000000080000000
#define ADM4			0x0000000100000000
#define ADM5			0x0000000200000000
#define PWD0			0x0000000400000000
#define PWD1			0x0000000800000000
#define PWD2			0x0000001000000000
#define PWD3			0x0000002000000000
#define FAKE0			0x0000004000000000
#define FAKE1			0x0000008000000000
#define SPAM0			0x0000010000000000
#define SPAM1			0x0000020000000000
#define SPAM2			0x0000040000000000
#define SPAM3			0x0000080000000000
#define SPAM4			0x0000100000000000
#define CONNECT5		0x0000200000000000
#define CONNECT6		0x0000400000000000
#define USERIP			0x0000800000000000
#define ADM6			0x0001000000000000
#define RSVD2			0x0002000000000000
#define RSVD3			0x0004000000000000
#define RSVD4			0x0008000000000000
#define RSVD5			0x0010000000000000
#define RSVD6			0x0020000000000000
#define PLUG1			0x0040000000000000
#define PLUG2			0x0080000000000000
#define PLUG3			0x0100000000000000
#define PLUG4			0x0200000000000000
#define PLUG5			0x0400000000000000
#define PLUG6			0x0800000000000000
#define PLUG7			0x1000000000000000
#define PLUG8			0x2000000000000000
#define PLUG9			0x4000000000000000
#define PLUG10			0x8000000000000000

#define HEXHUBAPI __stdcall

typedef FARPROC (HEXHUBAPI *lpfnGetFunction)(const char *);
typedef void (HEXHUBAPI *lpfnCreateAccount)(const char *, const char *, const char *, const char *, SDWORD);
typedef bool (HEXHUBAPI *lpfnDeleteAccount)(SDWORD);
typedef bool (HEXHUBAPI *lpfnMoveAccount)(SDWORD, SDWORD, SDWORD);
typedef bool (HEXHUBAPI *lpfnSetProfile)(SDWORD, const char *, profileInfo *, const char *, const char *);
typedef bool (HEXHUBAPI *lpfnGetProfile)(SDWORD, char *, profileInfo *, char *, char *);
typedef SDWORD (HEXHUBAPI *lpfnGetNextProfile)(SDWORD);
typedef bool (HEXHUBAPI *lpfnSetAccount)(SDWORD, accountInfo *);
typedef bool (HEXHUBAPI *lpfnGetAccount)(SDWORD, accountInfo *);
typedef SDWORD (HEXHUBAPI *lpfnGetNextAccount)(SDWORD, SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnGetVersion)(void);
typedef SDWORD (HEXHUBAPI *lpfnGetUserCount)(void);
typedef SDWORD (HEXHUBAPI *lpfnGetUserIds)(SDWORD *, SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnGetMastersCount)(void);
typedef SDWORD (HEXHUBAPI *lpfnGetMastersIds)(SDWORD *, SDWORD);
typedef bool (HEXHUBAPI *lpfnGetIpCacheInfo)(SDWORD, ipInfo *);
typedef void (HEXHUBAPI *lpfnSetIpCacheInfo)(ipInfo *);
typedef SDWORD (HEXHUBAPI *lpfnRegisterCommand)(const char *, void *);
typedef bool (HEXHUBAPI *lpfnUnregisterCommand)(SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnRegisterHelpString)(const char *, const char *, SDWORD);
typedef bool (HEXHUBAPI *lpfnUnregisterHelpString)(SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnRegisterUserCommand)(const char *);
typedef bool (HEXHUBAPI *lpfnUnregisterUserCommand)(SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnRegisterChatFilter)(const char *, FARPROC, const char *);
typedef bool (HEXHUBAPI *lpfnUnregisterChatFilter)(SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnRegisterBot)(const char *, FARPROC);
typedef SDWORD (HEXHUBAPI *lpfnRegisterBotEx)(const char *, FARPROC, SDWORD, SDWORD, SDWORD);
typedef bool (HEXHUBAPI *lpfnUnregisterBot)(SDWORD);
typedef bool (HEXHUBAPI *lpfnCallHubCommand)(SDWORD, const char *);
typedef bool (HEXHUBAPI *lpfnProcessUserTraffic)(SDWORD, FARPROC, SDWORD, SDWORD);
typedef bool (HEXHUBAPI *lpfnDisableOutputToUser)(SDWORD, FARPROC, bool);
typedef void (HEXHUBAPI *lpfnAcceptUser)(SOCKET, SDWORD);
typedef bool (HEXHUBAPI *lpfnDisconnectUser)(SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnGetTopic)(char *, SDWORD);
typedef void (HEXHUBAPI *lpfnSetTopic)(const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetMOTD)(char *, SDWORD);
typedef void (HEXHUBAPI *lpfnSetMOTD)(const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetHubUptime)(void);
typedef SDWORD (HEXHUBAPI *lpfnGetHublistEntry)(SDWORD, char *, SDWORD);
typedef bool (HEXHUBAPI *lpfnSetBan)(SDWORD, SDWORD, SDWORD, char *, char *, SDWORD);
typedef bool (HEXHUBAPI *lpfnSendTo)(SDWORD, const char *, int);
typedef void (HEXHUBAPI *lpfnSendToAll)(const char *, int);
typedef void (HEXHUBAPI *lpfnSendNotificationMessage)(const char *);
typedef void (HEXHUBAPI *lpfnHTTPSendTo)(SDWORD, const char *, int, char *);
typedef void (HEXHUBAPI *lpfnHTTPSendHeaders)(SDWORD, const char *, int, char *);
typedef void (HEXHUBAPI *lpfnHTTPRedirect)(SDWORD, const char *);
typedef bool (HEXHUBAPI *lpfnNickFromId)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnClientNickFromId)(SDWORD, char *);
typedef SDWORD (HEXHUBAPI *lpfnIdFromNick)(const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetInfo)(SDWORD, char *);
typedef SDWORD (HEXHUBAPI *lpfnGetFullInfo)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnSetInfo)(SDWORD, const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetDescription)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnSetDescription)(SDWORD, const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetTag)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnSetTag)(SDWORD, const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetConnection)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnSetConnection)(SDWORD, const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetMail)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnSetMail)(SDWORD, const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetShareString)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnSetShareString)(SDWORD, const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetIP)(SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnGetIPString)(SDWORD, char *);
typedef SDWORD (HEXHUBAPI *lpfnGetISPName)(SDWORD, char *);
typedef SDWORD (HEXHUBAPI *lpfnGetOpStatus)(SDWORD);
typedef bool (HEXHUBAPI *lpfnSetOpStatus)(SDWORD, SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnGetLanguage)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnSetLanguage)(SDWORD, const char *);
typedef SDWORD (HEXHUBAPI *lpfnGetMode)(SDWORD, char *);
typedef bool (HEXHUBAPI *lpfnSetMode)(SDWORD, const char *);
typedef SDWORD (HEXHUBAPI *lpfnModeTransform)(const char *, const char *, char *);
typedef SDWORD (HEXHUBAPI *lpfnAllocUserData)(void);
typedef bool (HEXHUBAPI *lpfnFreeUserData)(SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnGetUserData)(SDWORD, SDWORD);
typedef bool (HEXHUBAPI *lpfnSetUserData)(SDWORD, SDWORD, char);
typedef int (HEXHUBAPI *lpfnFirewallGetVersion)(void);
typedef int (HEXHUBAPI *lpfnFirewallGetAboutString)(char *, int);
typedef int (HEXHUBAPI *lpfnFirewallEnable)(void);
typedef int (HEXHUBAPI *lpfnFirewallDisable)(void);
typedef int (HEXHUBAPI *lpfnFirewallBanRange)(iprange *);
typedef int (HEXHUBAPI *lpfnFirewallUnbanRange)(iprange *);
typedef short (HEXHUBAPI *lpfnFirewallLookupRange)(iprange *);
typedef int (HEXHUBAPI *lpfnFirewallGetSettings)(firewallSettingsInfo *);
typedef int (HEXHUBAPI *lpfnFirewallChangeSettings)(firewallSettingsInfo *);
typedef int (HEXHUBAPI *lpfnFirewallRegisterHubPort)(SDWORD);
typedef int (HEXHUBAPI *lpfnFirewallUnregisterHubPort)(SDWORD);
typedef int (HEXHUBAPI *lpfnFirewallGetStats)(firewallStatisticsInfo *);
typedef int (HEXHUBAPI *lpfnFirewallGetPortStats)(int, SDWORD *);
typedef int (HEXHUBAPI *lpfnDDoSFilterIP)(SDWORD);
typedef int (HEXHUBAPI *lpfnDDoSDeleteFilter)(void);
typedef int (HEXHUBAPI *lpfnDDoSCountFilteredIPs)(void);
typedef int (HEXHUBAPI *lpfnDDoSGetFilter)(void *, int);
typedef bool (HEXHUBAPI *lpfnGetRights)(SDWORD, SQWORD *);
typedef bool (HEXHUBAPI *lpfnSetRights)(SDWORD, SQWORD *);
typedef SDWORD (HEXHUBAPI *lpfnGetAccessLevel)(SDWORD);
typedef bool (HEXHUBAPI *lpfnSetAccessLevel)(SDWORD, SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnGetProfileId)(SDWORD);
typedef SDWORD (HEXHUBAPI *lpfnGetAccountId)(SDWORD);
typedef HWND (HEXHUBAPI *lpfnGetHubWindow)(void);







class HexHub
{
public:
	static lpfnGetFunction			GetFunction;
	bool Initialize(lpfnGetFunction GetFunction);
#if (HEX_VERSION >= 501)
	class Window
	{
	public:
		static lpfnGetHubWindow					GetHubWindow;
	};
#endif
	class Core
	{
	public:
		class Accounts
		{
		public:
			static lpfnCreateAccount			CreateAccount;
			static lpfnDeleteAccount			DeleteAccount;
			static lpfnMoveAccount				MoveAccount;
			static lpfnSetProfile				SetProfile;
			static lpfnGetProfile				GetProfile;
			static lpfnGetNextProfile			GetNextProfile;
			static lpfnSetAccount				SetAccount;
			static lpfnGetAccount				GetAccount;
			static lpfnGetNextAccount			GetNextAccount;
		};
		static lpfnGetVersion					GetVersion;
		static lpfnGetUserCount					GetUserCount;
		static lpfnGetUserIds					GetUserIds;
		static lpfnGetMastersCount				GetMastersCount;
		static lpfnGetMastersIds				GetMastersIds;
		static lpfnGetIpCacheInfo				GetIpCacheInfo;
		static lpfnSetIpCacheInfo				SetIpCacheInfo;
		static lpfnRegisterCommand				RegisterCommand;
		static lpfnUnregisterCommand			UnregisterCommand;
		static lpfnRegisterHelpString			RegisterHelpString;
		static lpfnUnregisterHelpString			UnregisterHelpString;
		static lpfnRegisterUserCommand			RegisterUserCommand;
		static lpfnUnregisterUserCommand		UnregisterUserCommand;
		static lpfnRegisterChatFilter			RegisterChatFilter;
		static lpfnUnregisterChatFilter			UnregisterChatFilter;
		static lpfnRegisterBot					RegisterBot;
#if (HEX_VERSION >= 317)
		static lpfnRegisterBotEx				RegisterBotEx;
#endif
		static lpfnUnregisterBot				UnregisterBot;
		static lpfnCallHubCommand				CallHubCommand;
		static lpfnAcceptUser					AcceptUser;
		static lpfnDisconnectUser				DisconnectUser;
#if (HEX_VERSION >= 307)
		static lpfnGetTopic						GetTopic;
		static lpfnSetTopic						SetTopic;
		static lpfnGetMOTD						GetMOTD;
		static lpfnSetMOTD						SetMOTD;
#endif
#if (HEX_VERSION >= 311)
		static lpfnGetHubUptime					GetHubUptime;
#endif
#if (HEX_VERSION >= 315)
		static lpfnGetHublistEntry				GetHublistEntry;
#endif
#if (HEX_VERSION >= 320)
		static lpfnSetBan						SetBan;
#endif
	};
	class Data
	{
	public:
		static lpfnSendTo						SendTo;
		static lpfnSendToAll					SendToAll;
		static lpfnSendNotificationMessage		SendNotificationMessage;
	};
#if (HEX_VERSION >= 500)
	class HTTP
	{
	public:
		static lpfnHTTPSendTo		HTTPSendTo;
		//static lpfnHTTPSendHeaders	HTTPSendHeaders;
		static lpfnHTTPRedirect		HTTPRedirect;
	};
#endif
	class Users
	{
	public:
		class Registration
		{
		public:
			static lpfnGetRights			GetRights;
			static lpfnSetRights			SetRights;
			static lpfnGetAccessLevel		GetAccessLevel;
			static lpfnSetAccessLevel		SetAccessLevel;
			static lpfnGetProfileId			GetProfileId;
			static lpfnGetAccountId			GetAccountId;
		};
		class Traffic
		{
		public:
			static lpfnProcessUserTraffic		ProcessUserTraffic;
			static lpfnDisableOutputToUser		DisableOutputToUser;
		};
		static lpfnNickFromId				NickFromId;
		static lpfnClientNickFromId			ClientNickFromId;
		static lpfnIdFromNick				IdFromNick;
		static lpfnGetInfo					GetInfo;
		static lpfnGetFullInfo				GetFullInfo;
		static lpfnSetInfo					SetInfo;
		static lpfnGetDescription			GetDescription;
		static lpfnSetDescription			SetDescription;
		static lpfnGetTag					GetTag;
		static lpfnSetTag					SetTag;
		static lpfnGetConnection			GetConnection;
		static lpfnSetConnection			SetConnection;
		static lpfnGetMail					GetMail;
		static lpfnSetMail					SetMail;
		static lpfnGetShareString			GetShareString;
		static lpfnSetShareString			SetShareString;
		static lpfnGetIP					GetIP;
		static lpfnGetIPString				GetIPString;
		static lpfnGetISPName				GetISPName;
		static lpfnGetOpStatus				GetOpStatus;
		static lpfnSetOpStatus				SetOpStatus;
		static lpfnGetLanguage				GetLanguage;
		static lpfnSetLanguage				SetLanguage;
		static lpfnGetMode					GetMode;
		static lpfnSetMode					SetMode;
		static lpfnModeTransform			ModeTransform;
		static lpfnAllocUserData			AllocUserData;
		static lpfnFreeUserData				FreeUserData;
		static lpfnGetUserData				GetUserData;
		static lpfnSetUserData				SetUserData;
	};
#if (HEX_VERSION >= 400)
	class Firewall
	{
	public:
		static lpfnFirewallGetVersion			FirewallGetVersion;
		static lpfnFirewallGetAboutString		FirewallGetAboutString;
		static lpfnFirewallEnable				FirewallEnable;
		static lpfnFirewallDisable				FirewallDisable;
		static lpfnFirewallBanRange				FirewallBanRange;
		static lpfnFirewallUnbanRange			FirewallUnbanRange;
		static lpfnFirewallLookupRange			FirewallLookupRange;
		static lpfnFirewallGetSettings			FirewallGetSettings;
		static lpfnFirewallChangeSettings		FirewallChangeSettings;
		static lpfnFirewallRegisterHubPort		FirewallRegisterHubPort;
		static lpfnFirewallUnregisterHubPort	FirewallUnregisterHubPort;
		static lpfnFirewallGetStats				FirewallGetStats;
		static lpfnFirewallGetPortStats			FirewallGetPortStats;
		static lpfnDDoSFilterIP					DDoSFilterIP;
		static lpfnDDoSDeleteFilter				DDoSDeleteFilter;
		static lpfnDDoSCountFilteredIPs			DDoSCountFilteredIPs;
		static lpfnDDoSGetFilter				DDoSGetFilter;
	};
#endif
	class HelperApi
	{
	public:
		class Math
		{
			static float GetPercentage(float fLowValue, float fHighValue);
		};
	};
};